#ifndef _DEVICESCTL_H_
#define _DEVICESCTL_H_

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdbool.h>
#include <libudev.h>
#include <time.h>
#include <gio/gio.h>
#include <libmount/libmount.h>
#include <pthread.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netdb.h>
#include <signal.h>
#include <pwd.h>
#include <stdarg.h>
#include <pthread.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netdb.h>
#include <signal.h>
#include <sys/types.h>
#include <ctype.h>
#include <ifaddrs.h>
#include <assert.h>
#include <poll.h>


#ifdef __cplusplus
extern "C" {
#endif

int connect_bus(char *usb_log);
int show_system_notification(char *usb_log);
int connect_hedronclient_bus(char *usb_log, int status);
void logging(const char *service_name, const char *level, const char *message);

int disabledevices(const char *devnum);
int enabledevices(const char *vid, const char *pid);

int DisableHidDevices();
int EnableHidDevices();
int GetHidDevices();

int DisableVideoDevices();
int EnableVideoDevices();
int GetVideoDevices();

int DisableStorageDevices();
int EnableStorageDevices();
int GetStorageDevices();
int ReadOnly(const char *path);

int SetWhiteList(const char *pid, const char *vid);
int SetBlackList(const char *pid, const char *vid);
int ClearWhiteList();
int ClearBlackList();
int DelWhiteList(const char *pid, const char *vid);
int DelBlackList(const char *pid, const char *vid);

int disable_usb_net_card();
int disable_acpi_net_card();
int enable_net_card();
int add_black_list(const char *pid, const char *vid);
int add_white_list(const char *pid, const char *vid);
int set_up_usb();

int get_interface_type(char *interface);

typedef void (*remount_cb)(const char *);

int readonlydevices(remount_cb);

#ifdef __cplusplus
}
#endif


#endif